var _Vue__default$version;
function _extends() {
  return _extends = Object.assign ? Object.assign.bind() : function(n) {
    for (var e = 1; e < arguments.length; e++) {
      var t2 = arguments[e];
      for (var r in t2) ({}).hasOwnProperty.call(t2, r) && (n[r] = t2[r]);
    }
    return n;
  }, _extends.apply(null, arguments);
}
import * as Vue from "vue";
import Vue__default from "vue";
import * as compositionHooks from "@vue/composition-api";
import { t } from "@opentinyvue/vue-locale";
import "@opentinyvue/vue-theme/base/index.css";
import { debounce, isServer } from "@opentinyvue/utils";
import { useInstanceSlots as useInstanceSlots$1, useRelation as useRelation$1 } from "@opentinyvue/vue-hooks";
var emitter = function emitter2() {
  var listeners = {};
  var on = function on2(event, callback, once) {
    if (once === void 0) {
      once = false;
    }
    if (event && typeof event === "string" && typeof callback === "function") {
      var callbacks = listeners[event] || [];
      listeners[event] = callbacks;
      callbacks.push(callback);
      callback.once = once;
    }
  };
  var emitter22 = {
    emit: function emit(eventName) {
      var _arguments = arguments;
      var callbacks = listeners[eventName];
      if (callbacks) {
        callbacks.forEach(function(callback) {
          return callback.apply(null, [].slice.call(_arguments, 1));
        });
        listeners[eventName] = callbacks.filter(function(callback) {
          return !callback.once;
        });
      }
    },
    on,
    once: function once(event, callback) {
      on(event, callback, true);
    },
    off: function off(event, callback) {
      if (event && typeof event === "string") {
        var callbacks = listeners[event];
        if (typeof callback === "function") {
          listeners[event] = callbacks.filter(function(cb) {
            return cb !== callback;
          });
        } else {
          delete listeners[event];
        }
      } else {
        listeners = {};
      }
    }
  };
  return emitter22;
};
var bindFilter = function bindFilter2(props2, attrs) {
  if (attrs === void 0) {
    attrs = {};
  }
  var properties = {};
  for (var name in props2) {
    if (name.indexOf("_") !== 0) {
      properties[name] = props2[name];
    }
  }
  for (var _name in attrs) {
    properties[_name] = attrs[_name];
  }
  return properties;
};
var getElementStatusClass = function getElementStatusClass2(className, status) {
  if (!className || !status) return;
  var classNames = [];
  if (typeof className === "string") {
    classNames.push(className);
  } else if (Array.isArray(className)) {
    classNames = className;
  }
  var statusList = [];
  if (typeof status === "string") {
    statusList.push(status);
  } else if (Array.isArray(status)) {
    statusList = status;
  }
  var res = [];
  statusList.forEach(function(status2) {
    return classNames.forEach(function(name) {
      return res.push(status2 + ":" + name + "-" + status2);
    });
  });
  return classNames.concat(res).join(" ");
};
var getElementCssClass = function getElementCssClass2(classes, key) {
  if (classes === void 0) {
    classes = {};
  }
  if (typeof key === "object") {
    var keys = Array.isArray(key) ? key : Object.keys(key).filter(function(k) {
      return key[k];
    });
    var cls = "";
    keys.forEach(function(k) {
      if (classes[k]) cls += classes[k] + " ";
    });
    return cls;
  } else {
    return classes[key] || "";
  }
};
var globalId = 0;
var getHasComment = function getHasComment2(state) {
  return function(comment) {
    var childNodes = state.parent ? Array.from(state.parent.childNodes) : [];
    for (var i = 0; i < childNodes.length; i++) {
      if (childNodes[i].textContent === comment) {
        return true;
      }
    }
  };
};
var getGetFragment = function getGetFragment2(_ref) {
  var hasComment = _ref.hasComment, startComment = _ref.startComment, state = _ref.state, endComment = _ref.endComment;
  return function(commentFlag) {
    var fragment = document.createDocumentFragment();
    if (commentFlag) {
      !hasComment(startComment) && fragment.appendChild(document.createComment(startComment));
      state.nodes.forEach(function(node2) {
        return fragment.appendChild(node2);
      });
      !hasComment(endComment) && fragment.appendChild(document.createComment(endComment));
    } else {
      var _children = state.parent ? Array.from(state.parent.childNodes) : [];
      var start, end;
      start = end = 0;
      for (var i = 0; i < _children.length; i++) {
        var node = _children[i];
        if (node.nodeType !== 8) {
          continue;
        }
        if (node.textContent === startComment) {
          start = i;
        }
        if (node.textContent === endComment) {
          end = i;
          break;
        }
      }
      if (end > start) {
        _children.slice(start + 1, end).forEach(function(node2) {
          return fragment.appendChild(node2);
        });
      }
    }
    return fragment;
  };
};
var getDisable = function getDisable2(_ref2) {
  var instance = _ref2.instance, getFragment = _ref2.getFragment, state = _ref2.state, startComment = _ref2.startComment, endComment = _ref2.endComment;
  return function() {
    instance.$el.appendChild(getFragment());
    var indices = [];
    var children3 = state.parent ? Array.from(state.parent.childNodes) : [];
    children3.forEach(function(child, i) {
      if (child.nodeType === 8) {
        if (child.textContent === startComment || child.textContent === endComment) {
          indices.push(i);
        }
      }
    });
    var minIndex = Math.min.apply(Math, indices);
    var maxIndex = Math.max.apply(Math, indices);
    children3.slice(minIndex, maxIndex + 1).reverse().forEach(function(child) {
      return state.parent && state.parent.removeChild(child);
    });
    state.parent = null;
  };
};
var getMove = function getMove2(_ref3) {
  var state = _ref3.state, props2 = _ref3.props, disable = _ref3.disable, getFragment = _ref3.getFragment;
  return function() {
    state.waiting = false;
    state.parent = document.querySelector(props2.to);
    if (!state.parent) {
      disable();
      state.waiting = true;
      return;
    }
    if (props2.where === "before") {
      state.parent.prepend(getFragment(true));
    } else {
      state.parent.appendChild(getFragment(true));
    }
  };
};
var getTeardownObserver = function getTeardownObserver2(state) {
  return function() {
    if (state.observer) {
      state.observer.disconnect();
      state.observer = null;
    }
  };
};
var getOnMutations = function getOnMutations2(_ref4) {
  var state = _ref4.state, disable = _ref4.disable, props2 = _ref4.props, move = _ref4.move;
  return function(mutations) {
    var shouldMove = false;
    for (var i = 0; i < mutations.length; i++) {
      var mutation = mutations[i];
      var filteredAddedNodes = Array.from(mutation.addedNodes).filter(function(node) {
        return !state.nodes.includes(node);
      });
      if (Array.from(mutation.removedNodes).includes(state.parent)) {
        disable();
        state.waiting = !props2.disabled;
      } else if (state.waiting && filteredAddedNodes.length > 0) {
        shouldMove = true;
      }
    }
    shouldMove && move();
  };
};
var getBootObserver = function getBootObserver2(_ref5) {
  var state = _ref5.state, onMutations = _ref5.onMutations;
  return function() {
    if (state.observer) return;
    state.observer = new MutationObserver(function(mutations) {
      return onMutations(mutations);
    });
    state.observer.observe(document.body, {
      attributes: false,
      characterData: false,
      childList: true,
      subtree: true
    });
  };
};
var getAfterUpdated = function getAfterUpdated2(_ref6) {
  var state = _ref6.state, instance = _ref6.instance, props2 = _ref6.props, bootObserver = _ref6.bootObserver, maybeMove = _ref6.maybeMove;
  return function() {
    state.nodes = Array.from(instance.$el.childNodes);
    !props2.disabled && bootObserver();
    maybeMove();
  };
};
var getWatchDisabled = function getWatchDisabled2(_ref7) {
  var disable = _ref7.disable, teardownObserver = _ref7.teardownObserver, bootObserver = _ref7.bootObserver, move = _ref7.move;
  return function(value) {
    if (value) {
      disable();
      teardownObserver();
      return;
    }
    bootObserver();
    move();
  };
};
var teleport = function teleport2(_ref8) {
  var reactive = _ref8.reactive, watch = _ref8.watch, getCurrentInstance = _ref8.getCurrentInstance, onUpdated = _ref8.onUpdated, onMounted = _ref8.onMounted, onBeforeUnmount = _ref8.onBeforeUnmount, h2 = _ref8.h, defineComponent2 = _ref8.defineComponent;
  return defineComponent2({
    name: "Vue2Teleport",
    props: {
      to: {
        type: String,
        required: true
      },
      where: {
        type: String,
        default: "after"
      },
      disabled: Boolean
    },
    setup: function setup3(props2) {
      var _getCurrentInstance;
      var state = reactive({
        nodes: [],
        waiting: false,
        observer: null,
        parent: null,
        id: ++globalId
      });
      var instance = (_getCurrentInstance = getCurrentInstance()) == null ? void 0 : _getCurrentInstance.proxy;
      var startComment = "[" + state.id + "]vue2-teleporter-start";
      var endComment = "[" + state.id + "]vue2-teleporter-end";
      var hasComment = getHasComment(state);
      var getFragment = getGetFragment({
        hasComment,
        startComment,
        state,
        endComment
      });
      var disable = getDisable({
        instance,
        getFragment,
        state,
        startComment,
        endComment
      });
      var move = getMove({
        state,
        props: props2,
        disable,
        getFragment
      });
      var maybeMove = function maybeMove2() {
        return !props2.disabled && move();
      };
      var teardownObserver = getTeardownObserver(state);
      var onMutations = getOnMutations({
        state,
        disable,
        props: props2,
        move
      });
      var bootObserver = getBootObserver({
        state,
        onMutations
      });
      var afterUpdated = getAfterUpdated({
        state,
        instance,
        props: props2,
        bootObserver,
        maybeMove
      });
      var watchDisabled = getWatchDisabled({
        disable,
        teardownObserver,
        bootObserver,
        move
      });
      watch(function() {
        return props2.to;
      }, maybeMove);
      watch(function() {
        return props2.where;
      }, maybeMove);
      watch(function() {
        return props2.disabled;
      }, watchDisabled);
      onUpdated(afterUpdated);
      onMounted(afterUpdated);
      onBeforeUnmount(function() {
        disable();
        teardownObserver();
      });
      return function() {
        return h2("div", {
          class: "vue2-teleporter",
          style: {
            "visibility:hidden;display:none;": !props2.disabled
          }
        }, (typeof (instance == null ? void 0 : instance.$slots.default) === "function" ? instance.$slots.default() : instance.$slots.default) || null);
      };
    }
  });
};
var isVueHooks = Boolean((_Vue__default$version = Vue__default.version) == null ? void 0 : _Vue__default$version.includes("2.7"));
var hooks = isVueHooks ? Vue : compositionHooks;
var Teleport = teleport(hooks);
if (!hooks.default.__composition_api_installed__ && !isVueHooks) {
  Vue__default.use(hooks.default);
}
var defineAsyncComponent = function defineAsyncComponent2(_ref9) {
  var loader = _ref9.loader, loadingComponent = _ref9.loadingComponent, errorComponent = _ref9.errorComponent, delay = _ref9.delay, timeout = _ref9.timeout;
  return function() {
    return {
      component: loader(),
      loading: loadingComponent,
      error: errorComponent,
      delay,
      timeout
    };
  };
};
var markRaw = function markRaw2(ref) {
  return ref;
};
var renderComponent = function renderComponent2(_ref10) {
  var _ref10$view = _ref10.view, view = _ref10$view === void 0 ? null : _ref10$view, _ref10$component = _ref10.component, component = _ref10$component === void 0 ? null : _ref10$component, props2 = _ref10.props, _ref10$context = _ref10.context, attrs = _ref10$context.attrs, on = _ref10$context.listeners, slots = _ref10$context.slots, _ref10$extend = _ref10.extend, extend = _ref10$extend === void 0 ? {} : _ref10$extend;
  return function() {
    var _Object$assign;
    return hooks.h(view && view.value || component, Object.assign((_Object$assign = {
      props: props2,
      attrs
    }, _Object$assign[extend.isSvg ? "nativeOn" : "on"] = on, _Object$assign.ref = "modeTemplate", _Object$assign.scopedSlots = _extends({}, slots), _Object$assign), extend));
  };
};
var rootConfig = function rootConfig2() {
  var _hooks$getCurrentInst;
  return (_hooks$getCurrentInst = hooks.getCurrentInstance()) == null ? void 0 : _hooks$getCurrentInst.proxy.$root;
};
var getComponentName = function getComponentName2() {
  var _instance$vnode, _instance$vnode$compo, _instance$vnode$compo2, _instance$vnode$compo3;
  var instance = hooks.getCurrentInstance();
  var componentName = instance == null ? void 0 : (_instance$vnode = instance.vnode) == null ? void 0 : (_instance$vnode$compo = _instance$vnode.componentOptions) == null ? void 0 : (_instance$vnode$compo2 = _instance$vnode$compo.Ctor) == null ? void 0 : (_instance$vnode$compo3 = _instance$vnode$compo2.extendOptions) == null ? void 0 : _instance$vnode$compo3.name;
  if (!componentName) {
    var _instance$parent, _instance$parent$vnod, _instance$parent$vnod2, _instance$parent$vnod3, _instance$parent$vnod4;
    componentName = instance == null ? void 0 : (_instance$parent = instance.parent) == null ? void 0 : (_instance$parent$vnod = _instance$parent.vnode) == null ? void 0 : (_instance$parent$vnod2 = _instance$parent$vnod.componentOptions) == null ? void 0 : (_instance$parent$vnod3 = _instance$parent$vnod2.Ctor) == null ? void 0 : (_instance$parent$vnod4 = _instance$parent$vnod3.extendOptions) == null ? void 0 : _instance$parent$vnod4.name;
  }
  return componentName || "";
};
var appContext = function appContext2() {
  return Vue__default;
};
var appProperties = function appProperties2() {
  return Vue__default.prototype;
};
var useRouter = function useRouter2(instance) {
  var _instance, _instance2;
  if (instance === void 0) {
    var _hooks$getCurrentInst2;
    instance = (_hooks$getCurrentInst2 = hooks.getCurrentInstance()) == null ? void 0 : _hooks$getCurrentInst2.proxy;
  }
  return {
    route: (_instance = instance) == null ? void 0 : _instance.$route,
    router: (_instance2 = instance) == null ? void 0 : _instance2.$router
  };
};
var emitEvent = function emitEvent2(vm) {
  var _broadcast = function broadcast(vm2, componentName, eventName, params) {
    vm2.$children.forEach(function(child) {
      var name = child.$options.componentName;
      if (name === componentName) child.$emit(eventName, params);
      else _broadcast(child, componentName, eventName, params);
    });
  };
  return {
    dispatch: function dispatch(componentName, eventName, params) {
      var _parent;
      var parent22 = vm.$parent || vm.$root;
      var name = parent22.$options.componentName;
      while (parent22 && (!name || name !== componentName)) {
        parent22 = parent22.$parent;
        if (parent22) name = parent22.$options.componentName;
      }
      if (parent22) (_parent = parent22).$emit.apply(_parent, [eventName].concat(params));
    },
    broadcast: function broadcast(componentName, eventName, params) {
      _broadcast(vm, componentName, eventName, params);
    }
  };
};
var parent = function parent2(vm) {
  return function(handler) {
    var parent22 = vm.$parent;
    var level = 0;
    var parentObject = function parentObject2(parent3) {
      return {
        level,
        vm: _createVm({}, parent3),
        el: parent3.$el,
        options: parent3.$options
      };
    };
    if (typeof handler !== "function") return parent22 ? parentObject(parent22) : {};
    level++;
    while (parent22) {
      if (handler(parentObject(parent22))) break;
      parent22 = parent22.$parent;
      level++;
    }
  };
};
var children = function children2(vm) {
  return function(handler) {
    if (typeof handler !== "function") return generateChildren(vm.$children);
    var layer = 1;
    var _broadcast2 = function broadcast($children) {
      var level = layer++;
      if ($children.some(function(child) {
        return handler({
          level,
          vm: _createVm({}, child),
          el: child.$el,
          options: child.$options,
          isLevel1: level === 1
        });
      })) return;
      $children.forEach(function(child) {
        return _broadcast2(child.$children);
      });
    };
    _broadcast2(vm.$children);
  };
};
var generateChildren = function generateChildren2($children) {
  var children22 = [];
  children22.refs = {};
  $children.forEach(function(child) {
    var vm = _createVm({}, child);
    children22.push(vm);
    child.$vnode.data.ref && (children22.refs[child.$vnode.data.ref] = vm);
  });
  return children22;
};
var defineProperties = function defineProperties2(vm, instance, filter22) {
  var _loop = function _loop2(name2) {
    if (typeof filter22 === "function" && filter22(name2)) return 1;
    Object.defineProperty(vm, name2, {
      configurable: true,
      enumerable: true,
      get: function get() {
        return instance[name2];
      },
      set: function set(value) {
        return instance[name2] = value;
      }
    });
  };
  for (var name in instance) {
    if (_loop(name)) continue;
  }
  return vm;
};
var filter = function filter2(name) {
  return name.indexOf("$") === 0 || name.indexOf("_") === 0 || name === "constructor";
};
var _createVm = function createVm(vm, instance, context) {
  if (context === void 0) {
    context = void 0;
  }
  context || defineProperties(vm, instance, filter);
  Object.defineProperties(vm, {
    $attrs: {
      get: function get() {
        return instance.$attrs;
      }
    },
    $children: {
      get: function get() {
        return generateChildren(instance.$children);
      }
    },
    $constants: {
      get: function get() {
        return instance._constants;
      }
    },
    $emit: {
      get: function get() {
        return instance.$emit.bind(instance);
      }
    },
    $el: {
      get: function get() {
        return instance.$el;
      }
    },
    $listeners: {
      get: function get() {
        return instance.$listeners;
      }
    },
    $mode: {
      get: function get() {
        return instance._tiny_mode;
      }
    },
    $nextTick: {
      get: function get() {
        return hooks.nextTick;
      }
    },
    $off: {
      get: function get() {
        return instance.$off.bind(instance);
      }
    },
    $on: {
      get: function get() {
        return instance.$on.bind(instance);
      }
    },
    $once: {
      get: function get() {
        return instance.$once.bind(instance);
      }
    },
    $options: {
      get: function get() {
        return {
          componentName: instance.$options.componentName
        };
      }
    },
    $parent: {
      get: function get() {
        return instance.$parent && _createVm({}, instance.$parent);
      }
    },
    $refs: {
      get: function get() {
        return instance.$refs;
      }
    },
    $renderless: {
      get: function get() {
        return instance.tiny_renderless;
      }
    },
    $scopedSlots: {
      get: function get() {
        return instance.$scopedSlots;
      }
    },
    $set: {
      get: function get() {
        return instance.$set;
      }
    },
    $slots: {
      get: function get() {
        return instance.$scopedSlots;
      }
    },
    $template: {
      get: function get() {
        return instance.tiny_template;
      }
    }
  });
  return vm;
};
var onBeforeMount = function onBeforeMount2(instance, refs) {
  Object.keys(instance.$refs).forEach(function(key) {
    refs[key] = instance.$refs[key];
  });
};
var tools = function tools2(context, mode) {
  var _hooks$getCurrentInst3;
  var instance = (_hooks$getCurrentInst3 = hooks.getCurrentInstance()) == null ? void 0 : _hooks$getCurrentInst3.proxy;
  var root = instance == null ? void 0 : instance.$root;
  var _useRouter = useRouter(instance), route = _useRouter.route, router = _useRouter.router;
  var i18n = root == null ? void 0 : root.$i18n;
  var _emitEvent = emitEvent(instance), dispatch = _emitEvent.dispatch, broadcast = _emitEvent.broadcast;
  var parentHandler = parent(instance);
  var childrenHandler = children(instance);
  var vm = _createVm({}, instance, context);
  var emit = context.emit;
  var refs = {};
  var parentVm = instance.$parent ? _createVm({}, instance.$parent) : null;
  var setParentAttribute = function setParentAttribute2(_ref11) {
    var name = _ref11.name, value = _ref11.value;
    instance.$parent[name] = value;
    parentVm[name] = value;
  };
  var defineInstanceProperties = function defineInstanceProperties2(props2) {
    Object.defineProperties(vm, props2);
    Object.defineProperties(instance, props2);
  };
  var defineParentInstanceProperties = function defineParentInstanceProperties2(props2) {
    parentVm && Object.defineProperties(parentVm, props2);
  };
  hooks.onBeforeMount(function() {
    return defineProperties(vm, instance, filter);
  });
  if (Vue) {
    hooks.onMounted(function() {
      return onBeforeMount(instance, refs);
    });
  }
  return {
    framework: "vue2",
    vm,
    emit,
    emitter,
    route,
    router,
    dispatch,
    broadcast,
    parentHandler,
    childrenHandler,
    // 因为vue2.6版本context.refs是有值的，但是vue2.7版本是undefined所以这里需要做个兼容
    refs: Vue ? refs : context.refs,
    i18n,
    slots: context.slots,
    scopedSlots: context.slots,
    attrs: context.attrs,
    parent: parentVm,
    nextTick: hooks.nextTick,
    constants: instance == null ? void 0 : instance._constants,
    mode,
    isPCMode: mode === "pc",
    isMobileMode: mode === "mobile",
    service: instance == null ? void 0 : instance.$service,
    getService: function getService() {
      return instance == null ? void 0 : instance.$getService(vm);
    },
    setParentAttribute,
    defineInstanceProperties,
    defineParentInstanceProperties
  };
};
var mapping = function mapping2(content, before, after) {
  if (typeof content[before] !== "undefined") {
    var fn = content[before];
    content[after] = function(el, binding, vnode) {
      binding.instance = vnode.context;
      fn(el, binding, vnode);
    };
    delete content[before];
  }
};
var directive = function directive2(directives) {
  for (var name in directives) {
    var content = directives[name];
    mapping(content, "mounted", "inserted");
    mapping(content, "beforeMount", "bind");
    mapping(content, "updated", "update");
    mapping(content, "unmounted", "unbind");
  }
  return directives;
};
var bindVnodeData = function bindVnodeData2(_ref12) {
  var props2 = _ref12.props, data = _ref12.data, name = _ref12.name, _ref12$attr = _ref12.attr, attr = _ref12$attr === void 0 ? name : _ref12$attr;
  Object.defineProperty(props2, attr, {
    get: function get() {
      return data[name];
    },
    set: function set(value) {
      return data[name] = value;
    }
  });
};
var parseVnode = function parseVnode2(vnode) {
  var props2 = {};
  var data = vnode.componentOptions && vnode.componentOptions.propsData || {};
  for (var name in data) bindVnodeData({
    props: props2,
    data,
    name
  });
  vnode.props = props2;
  vnode.type = {
    name: vnode.componentOptions && vnode.componentOptions.tag
  };
  return vnode;
};
var isEmptyVnode = function isEmptyVnode2(vnode) {
  return !vnode || !vnode.tag;
};
var h = hooks.h;
var createComponentFn = function createComponentFn2(design2) {
  return function(_ref13) {
    var _provide;
    var component = _ref13.component, propsData = _ref13.propsData, el = _ref13.el;
    var comp = Object.assign(component, {
      provide: (_provide = {}, _provide[design2.configKey] = design2.configInstance, _provide)
    });
    return new (Vue__default.extend(comp))({
      propsData,
      el
    }).$mount();
  };
};
var defineComponent = hooks.defineComponent;
var isVue2 = true;
var isVue3 = false;
var isVnode = function isVnode2(vnode) {
  return ["isStatic", "isRootInsert", "isComment", "isCloned", "isOnce"].every(function(key) {
    return typeof vnode[key] !== "undefined";
  });
};
var KeepAlive = Vue__default.component("KeepAlive");
var stringifyCssClassObject = function stringifyCssClassObject2(cssClassObject) {
  var allCssClass = [];
  Object.keys(cssClassObject).forEach(function(cssClass) {
    return cssClassObject[cssClass] && allCssClass.push(cssClass);
  });
  return allCssClass.join(" ");
};
var stringifyCssClassArray = function stringifyCssClassArray2(cssClassArray) {
  var allCssClass = [];
  cssClassArray.forEach(function(cssClass) {
    if (typeof cssClass === "string") {
      allCssClass.push(cssClass);
    } else if (typeof cssClass === "object") {
      allCssClass.push(stringifyCssClassObject(cssClass));
    }
  });
  return allCssClass.join(" ");
};
var stringifyCssClass = function stringifyCssClass2(cssClasses) {
  if (!cssClasses) {
    return "";
  }
  if (typeof cssClasses === "string") {
    return cssClasses;
  }
  if (Array.isArray(cssClasses) && cssClasses.length > 0) {
    var allCssClass = [];
    cssClasses.forEach(function(cssClass) {
      if (cssClass) {
        if (typeof cssClass === "string") {
          allCssClass.push(cssClass);
        } else if (Array.isArray(cssClass)) {
          allCssClass.push(stringifyCssClassArray(cssClass));
        } else if (typeof cssClass === "object") {
          allCssClass.push(stringifyCssClassObject(cssClass));
        }
      }
    });
    return allCssClass.join(" ");
  }
  if (typeof cssClasses === "object") {
    return stringifyCssClassObject(cssClasses);
  }
  return "";
};
var deduplicateCssClass = function deduplicateCssClass2(cssClasses) {
  var classNames = stringifyCssClass(cssClasses);
  var classArray = Array.from(new Set(classNames.split(" "))).filter(function(i) {
    return i;
  });
  return stringifyCssClass(classArray);
};
var useBreakpoint = function useBreakpoint2() {
  var activeBreakpoint = hooks.ref("");
  var prefixes = ["2xl", "xl", "lg", "md", "sm"];
  var createMatchMedia = function createMatchMedia2(mediaQueryString) {
    if (isServer || typeof matchMedia !== "function") {
      return {
        matches: false,
        media: mediaQueryString,
        addEventListener: function addEventListener() {
        },
        removeEventListener: function removeEventListener() {
        }
      };
    } else {
      return window.matchMedia(mediaQueryString);
    }
  };
  var mediaQuerys = {
    "2xl": createMatchMedia("(min-width:1536px)"),
    "xl": createMatchMedia("(min-width:1280px)"),
    "lg": createMatchMedia("(min-width:1024px)"),
    "md": createMatchMedia("(min-width:768px)"),
    "sm": createMatchMedia("(min-width:640px)")
  };
  var setActiveBreakpoint = function setActiveBreakpoint2() {
    for (var i = 0; i < prefixes.length; i++) {
      var key = prefixes[i];
      if (mediaQuerys[key].matches) {
        activeBreakpoint.value = key;
        return;
      }
    }
    activeBreakpoint.value = "default";
  };
  var mediaQueryListener = debounce(0, function() {
    return setActiveBreakpoint();
  });
  setActiveBreakpoint();
  prefixes.forEach(function(key) {
    return mediaQuerys[key].addEventListener("change", mediaQueryListener);
  });
  hooks.onBeforeUnmount(function() {
    prefixes.forEach(function(key) {
      return mediaQuerys[key].removeEventListener("change", mediaQueryListener);
    });
  });
  return {
    current: activeBreakpoint
  };
};
function useDefer(maxCount) {
  if (maxCount === void 0) {
    maxCount = 100;
  }
  var frameCount = hooks.ref(0);
  var rafId;
  function updateFrameCount() {
    rafId = requestAnimationFrame(function() {
      frameCount.value++;
      if (frameCount.value >= maxCount) {
        return;
      }
      updateFrameCount();
    });
  }
  function cancel() {
    if (rafId) {
      cancelAnimationFrame(rafId);
      rafId = 0;
    }
  }
  updateFrameCount();
  hooks.onBeforeUnmount(function() {
    return cancel();
  });
  return {
    defer: function defer(n) {
      return frameCount.value >= n;
    },
    reset: function reset() {
      cancel();
      frameCount.value = 0;
      updateFrameCount();
    },
    cancel
  };
}
var GRADIENT_ICONS_LIST = ["IconLoadingShadow", "IconNoData"];
var uniqueId = 0;
var _generateId = function generateId(vnode, idMaps) {
  {
    var _vnode$data, _vnode$data$attrs;
    if ((_vnode$data = vnode.data) != null && (_vnode$data$attrs = _vnode$data.attrs) != null && _vnode$data$attrs.id) {
      var newId = "" + vnode.data.attrs.id + uniqueId;
      idMaps[vnode.data.attrs.id] = newId;
      vnode.data.attrs.id = newId;
    }
  }
  if (Array.isArray(vnode == null ? void 0 : vnode.children)) {
    vnode.children.forEach(function(item) {
      _generateId(item, idMaps);
    });
  }
};
var _generateUrl = function generateUrl(vnode, idMaps) {
  var checkList = ["fill", "mask", "filter"];
  checkList.forEach(function(item) {
    {
      var _vnode$data2, _vnode$data2$attrs, _vnode$data2$attrs$it;
      if ((_vnode$data2 = vnode.data) != null && (_vnode$data2$attrs = _vnode$data2.attrs) != null && (_vnode$data2$attrs$it = _vnode$data2$attrs[item]) != null && _vnode$data2$attrs$it.includes("url(#")) {
        var oldId = vnode.data.attrs[item].replace("url(#", "").replace(")", "");
        var newId = idMaps[oldId];
        if (newId) {
          vnode.data.attrs[item] = "url(#" + newId + ")";
        }
      }
    }
  });
  if (Array.isArray(vnode == null ? void 0 : vnode.children)) {
    vnode.children.forEach(function(item) {
      _generateUrl(item, idMaps);
    });
  }
};
var generateIcon = function generateIcon2(vnode) {
  if (!vnode) {
    return;
  }
  var idMaps = {};
  _generateId(vnode, idMaps);
  _generateUrl(vnode, idMaps);
  uniqueId++;
};
var version = "2.undefined";
var useInstanceSlots = useInstanceSlots$1(_extends({}, hooks, {
  isVue2
}));
var useRelation = useRelation$1(_extends({}, hooks, {
  isVue2
}));
var $prefix = "Tiny";
var $props = {
  "tiny_mode": String,
  "tiny_mode_root": Boolean,
  "tiny_template": [Function, Object],
  "tiny_renderless": Function,
  "tiny_theme": String,
  "tiny_chart_theme": Object
};
var props = ["tiny_mode", "tiny_mode_root", "tiny_template", "tiny_renderless", "_constants", "tiny_theme", "tiny_chart_theme"];
var resolveMode = function resolveMode2(props2, context) {
  var isRightMode = function isRightMode2(mode) {
    return ~["pc", "mobile", "mobile-first"].indexOf(mode);
  };
  var config = rootConfig();
  var tinyModeProp = typeof props2.tiny_mode === "string" ? props2.tiny_mode : null;
  var tinyModeInject = hooks.inject("TinyMode", null);
  var tinyModeGlobal;
  if (typeof config.tiny_mode === "string") {
    tinyModeGlobal = config.tiny_mode;
  } else if (config.tiny_mode) {
    tinyModeGlobal = config.tiny_mode.value;
  }
  if (!isRightMode(tinyModeProp)) tinyModeProp = null;
  if (!isRightMode(tinyModeInject)) tinyModeInject = null;
  if (!isRightMode(tinyModeGlobal)) tinyModeGlobal = null;
  var tinyMode = tinyModeProp || tinyModeInject || tinyModeGlobal || "pc";
  if (props2.tiny_mode_root) {
    hooks.provide("TinyMode", tinyMode);
  }
  var instance = hooks.getCurrentInstance();
  {
    instance = instance.proxy;
  }
  Object.defineProperty(instance, "_tiny_mode", {
    value: tinyMode
  });
  return tinyMode;
};
var resolveTheme = function resolveTheme2(props2, context) {
  var isRightTheme = function isRightTheme2(theme) {
    return ~["tiny", "saas"].indexOf(theme);
  };
  var config = rootConfig();
  var tinyThemeProp = typeof props2.tiny_theme === "string" ? props2.tiny_theme : null;
  var tinyThemeInject = hooks.inject("TinyTheme", null);
  var tinyThemeGlobal = config.tiny_theme && config.tiny_theme.value;
  if (!isRightTheme(tinyThemeProp)) tinyThemeProp = null;
  if (!isRightTheme(tinyThemeInject)) tinyThemeInject = null;
  if (!isRightTheme(tinyThemeGlobal)) tinyThemeGlobal = null;
  var tinyTheme = tinyThemeProp || tinyThemeInject || tinyThemeGlobal || "tiny";
  return tinyTheme;
};
var resolveChartTheme = function resolveChartTheme2(props2, context) {
  var config = rootConfig();
  var tinyChartProp = typeof props2.tiny_chart_theme === "object" ? props2.tiny_chart_theme : null;
  var tinyChartInject = hooks.inject("TinyChartTheme", null);
  var tinyChartGlobal = config.tiny_chart_theme && config.tiny_chart_theme.value;
  var tinyChartTheme = tinyChartProp || tinyChartInject || tinyChartGlobal || null;
  return tinyChartTheme;
};
var $setup = function $setup2(_ref14) {
  var props2 = _ref14.props, context = _ref14.context, template = _ref14.template, _ref14$extend = _ref14.extend, extend = _ref14$extend === void 0 ? {} : _ref14$extend;
  var mode = resolveMode(props2);
  var view = hooks.computed(function() {
    if (typeof props2.tiny_template !== "undefined") return props2.tiny_template;
    var component = template(mode, props2);
    return typeof component === "function" ? defineAsyncComponent(component) : component;
  });
  return renderComponent({
    view,
    props: props2,
    context,
    extend
  });
};
var design = {
  configKey: Symbol("designConfigKey"),
  configInstance: null
};
var provideDesignConfig = function provideDesignConfig2(designConfig) {
  if (Object.keys(designConfig).length) {
    hooks.provide(design.configKey, designConfig);
    design.configInstance = designConfig;
  }
};
var createComponent = createComponentFn(design);
var customDesignConfig = {
  designConfig: null,
  twMerge: function twMerge() {
    return "";
  }
};
var mergeClass = function mergeClass2() {
  for (var _len = arguments.length, cssClasses = new Array(_len), _key = 0; _key < _len; _key++) {
    cssClasses[_key] = arguments[_key];
  }
  return customDesignConfig.twMerge(stringifyCssClass(cssClasses));
};
var setup = function setup2(_ref15) {
  var _globalDesignConfig, _globalDesignConfig2, _globalDesignConfig2$;
  var props2 = _ref15.props, context = _ref15.context, renderless = _ref15.renderless, api = _ref15.api, _ref15$extendOptions = _ref15.extendOptions, extendOptions = _ref15$extendOptions === void 0 ? {} : _ref15$extendOptions, _ref15$mono = _ref15.mono, mono = _ref15$mono === void 0 ? false : _ref15$mono, _ref15$classes = _ref15.classes, classes = _ref15$classes === void 0 ? {} : _ref15$classes;
  var render = typeof props2.tiny_renderless === "function" ? props2.tiny_renderless : renderless;
  var globalDesignConfig = customDesignConfig.designConfig || hooks.inject(design.configKey, {});
  globalDesignConfig = ((_globalDesignConfig = globalDesignConfig) == null ? void 0 : _globalDesignConfig.value) || globalDesignConfig || {};
  var designConfig = (_globalDesignConfig2 = globalDesignConfig) == null ? void 0 : (_globalDesignConfig2$ = _globalDesignConfig2.components) == null ? void 0 : _globalDesignConfig2$[getComponentName().replace($prefix, "")];
  var utils = _extends({
    $prefix,
    t
  }, tools(context, resolveMode(props2)), {
    designConfig,
    globalDesignConfig,
    useBreakpoint,
    mergeClass
  });
  utils.vm.theme = resolveTheme(props2);
  utils.vm.chartTheme = resolveChartTheme(props2);
  var sdk = render(props2, hooks, utils, extendOptions);
  if (typeof (designConfig == null ? void 0 : designConfig.renderless) === "function") {
    Object.assign(sdk, designConfig.renderless(props2, hooks, utils, sdk));
  }
  var attrs = {
    t,
    vm: utils.vm,
    f: bindFilter,
    a: filterAttrs,
    d: utils.defineInstanceProperties,
    dp: utils.defineParentInstanceProperties,
    gcls: function gcls(key) {
      return getElementCssClass(classes, key);
    },
    m: mergeClass
  };
  attrs.d({
    slots: {
      get: function get() {
        return utils.vm.$slots;
      },
      configurable: true
    },
    scopedSlots: {
      get: function get() {
        return utils.vm.$scopedSlots;
      },
      configurable: true
    }
  });
  attrs.dp({
    slots: {
      get: function get() {
        return utils.parent.$slots;
      },
      configurable: true
    },
    scopedSlots: {
      get: function get() {
        return utils.parent.$scopedSlots;
      },
      configurable: true
    }
  });
  initComponent();
  if (Array.isArray(api)) {
    if (Array.isArray(designConfig == null ? void 0 : designConfig.api)) {
      api = api.concat(designConfig.api);
    }
    api.forEach(function(name) {
      var value = sdk[name];
      if (typeof value !== "undefined") {
        attrs[name] = value;
        if (!mono) {
          utils.setParentAttribute({
            name,
            value
          });
        }
      }
    });
  }
  return attrs;
};
function svg(_ref16) {
  var _ref16$name = _ref16.name, name = _ref16$name === void 0 ? "Icon" : _ref16$name, component = _ref16.component;
  return function(propData) {
    return markRaw(defineComponent({
      name: $prefix + name,
      setup: function setup3(props2, context) {
        var _ref17 = context.attrs || {}, fill = _ref17.fill, width = _ref17.width, height = _ref17.height, customClass = _ref17["custom-class"], firstColor = _ref17["first-color"], secondColor = _ref17["second-color"];
        var mergeProps = Object.assign({}, props2, propData || null);
        var mode = resolveMode(mergeProps);
        var isMobileFirst = mode === "mobile-first";
        var tinyTag = {
          "data-tag": isMobileFirst ? "tiny-svg" : null
        };
        var attrs = {
          attrs: tinyTag
        };
        var className = "tiny-svg";
        if (isMobileFirst) {
          className = mergeClass("h-4 w-4 inline-block", customClass || "", mergeProps.class || "");
        }
        var extend = Object.assign({
          style: {
            fill,
            width,
            height,
            "--tiny-first-color": firstColor || "",
            "--tiny-second-color": secondColor || ""
          },
          class: className,
          isSvg: true
        }, attrs);
        {
          extend.nativeOn = context.listeners;
        }
        if (GRADIENT_ICONS_LIST.includes(name)) {
          var render = component.render;
          component.render = function() {
            var newRender = render.bind(this);
            for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
              args[_key2] = arguments[_key2];
            }
            var vnode = newRender(args);
            generateIcon(vnode);
            return vnode;
          };
        }
        return renderComponent({
          component,
          props: mergeProps,
          context,
          extend
        });
      }
    }));
  };
}
var filterAttrs = function filterAttrs2(attrs, filters, include) {
  var props2 = {};
  var _loop2 = function _loop22(name2) {
    var find = filters.some(function(r) {
      return new RegExp(r).test(name2);
    });
    if (include && find || !include && !find) {
      props2[name2] = attrs[name2];
    }
  };
  for (var name in attrs) {
    _loop2(name);
  }
  return props2;
};
var setupComponent = {};
var initComponent = function initComponent2() {
  for (var name in setupComponent) {
    var component = setupComponent[name];
    if (typeof component.install === "function") {
      component.install(appContext());
    }
    if (typeof component.init === "function") {
      component.init(appProperties());
    }
  }
  setupComponent = {};
};
var $install = function $install2(component) {
  component.install = function(Vue2) {
    Vue2.component(component.name, component);
  };
};
var index = {
  h,
  directive,
  parseVnode,
  isEmptyVnode,
  useRouter,
  emitter,
  createComponent,
  defineAsyncComponent,
  filterAttrs,
  initComponent,
  setupComponent,
  svg,
  $prefix,
  $props,
  props,
  $setup,
  setup,
  hooks,
  getElementStatusClass,
  $install,
  isVnode
};
export {
  $install,
  $prefix,
  $props,
  $setup,
  KeepAlive,
  Teleport,
  appProperties,
  createComponent,
  customDesignConfig,
  deduplicateCssClass,
  index as default,
  defineAsyncComponent,
  defineComponent,
  design,
  directive,
  emitter,
  filterAttrs,
  getElementStatusClass,
  h,
  hooks,
  initComponent,
  isEmptyVnode,
  isVnode,
  isVue2,
  isVue3,
  mergeClass,
  parseVnode,
  props,
  provideDesignConfig,
  resolveMode,
  resolveTheme,
  setup,
  setupComponent,
  stringifyCssClass,
  stringifyCssClassArray,
  stringifyCssClassObject,
  svg,
  useBreakpoint,
  useDefer,
  useInstanceSlots,
  useRelation,
  useRouter,
  version
};
