interface CssClassObject {
    [k: string]: any;
}
type CssClassArray = Array<string | CssClassObject>;
export type CssClass = string | CssClassObject | CssClassArray;
/**
 * 简单合并 tailwind 类对象为字符串值
 *
 * @param cssClassObject tailwind 类对象
 * @returns string
 */
export declare const stringifyCssClassObject: (cssClassObject: CssClassObject) => string;
/**
 * 简单合并 tailwind 类数组为字符串值
 *
 * @param cssClassArray tailwind 类数组
 * @returns string
 */
export declare const stringifyCssClassArray: (cssClassArray: CssClassArray) => string;
/**
 * 简单合并 tailwind 类对象为字符串值，去重处理留给 tailwind-merge 处理
 *
 * @param {*} cssClasses tailwind 类集合
 * @returns string
 */
export declare const stringifyCssClass: (cssClasses: Array<CssClass> | CssClass) => string;
/**
 * 对类名做一个简单去重处理
 *
 * @param cssClasses 类集合
 * @returns string
 */
export declare const deduplicateCssClass: (cssClasses: Array<CssClass> | CssClass) => string;
export {};
